// L3DTio_DMF.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "L3DTio_DMF.h"

#include "..\Plugin API\ExtAPI.h"
extern CExtAPI theAPI;


#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

// CL3DTio_DMFApp

BEGIN_MESSAGE_MAP(CL3DTio_DMFApp, CWinApp)
END_MESSAGE_MAP()


// CL3DTio_DMFApp construction

CL3DTio_DMFApp::CL3DTio_DMFApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CL3DTio_DMFApp object

CL3DTio_DMFApp theApp;


// CL3DTio_DMFApp initialization

BOOL CL3DTio_DMFApp::InitInstance()
{
	CWinApp::InitInstance();

	return TRUE;
}


bool __stdcall ExtInitPlugin(FARPROC pFunc, LPVOID hID) {
	return theApp.InitPlugin(pFunc, hID);
}
bool __stdcall ExtSaveMapFile(ZMAP hMap, LPCSTR lpFileName, ZFORMAT hFormat, ZVAR hProgWnd) {
	return theApp.SaveMapFile(hMap, lpFileName, hFormat, hProgWnd);
}
bool __stdcall ExtLoadMapFile(ZMAP hMap, LPCSTR lpFileName, long MapTypeID, ZFORMAT hFormat, ZVAR hProgWnd) {
	return theApp.LoadMapFile(hMap, lpFileName, MapTypeID, hFormat, hProgWnd);
}

bool CL3DTio_DMFApp::InitPlugin(FARPROC pFunc, LPVOID hID) {

	// initalise the API
	if(!theAPI.InitAPI(pFunc, hID)) {
		AfxMessageBox("CL3DTio_DMFApp::InitPlugin error:\r\n - cannot load L3DT functions");
		return false;
	}

	//
	// add any further initialisation here
	//

	// create my format
	ZFORMAT hFormat = theAPI.format_Create("Design map", "L3DT Design Map File", "dmf", "L3DT");
	if(!hFormat) {
		// do nothing; this probably means the format already exists.
	} else {

		// set the flags
		theAPI.format_SetFlags(hFormat, true, false); // native I/O and mosaic

	}

	return true;
}

bool CL3DTio_DMFApp::SaveMapFile(ZMAP hMap, LPCSTR lpFileName, ZFORMAT hFormat, ZVAR hProgWnd) {

	// check the map type
	switch(theAPI.map_GetMapType(hMap)) {
	default:
		theAPI.ReportError("CL3DTio_DMFApp::SaveMapFile error:\r\n - unsupported map type");
		return false;
	case MAP_DesignMap:
		// OK
		break;
	}

	long nx = theAPI.map_GetWidth(hMap);
	long ny = theAPI.map_GetHeight(hMap);

	if(nx<=0||ny<=0) {
		theAPI.ReportError("CL3DTio_DMFApp::SaveDMF error\r\n - invalid map size");
		return false;
	}

	struct _iobuf *fh;

	// opening file for writing
	fh=fopen(lpFileName, "wb"); 
	if(fh==NULL) {
		CString TempStr;
		TempStr.Format("CL3DTio_DMFApp::SaveDMF error\r\n - cannot create file '%s'", lpFileName);
		theAPI.ReportError(TempStr);
		return false;
	}

	// preparing progress bar
	__int64 p, q, pmax, qstep;
	MSG TempMSG;
	if(hProgWnd) {
		theAPI.progbox_SetTitle(hProgWnd, "Saving DMF");
		theAPI.progbox_ShowWnd(hProgWnd);
		pmax = nx * ny;
		qstep = (__int64)pmax/50; // HACK!
		if(qstep<1)	qstep=1;
		else 		pmax=50;
		q=0, p=0;
	}


	int k;
	char TempBuf[10];
	CString TempStr;
	DesignMapPixel DMpxl;

	FileHeader_DMF FH_DM;

	char CharBuf[10];
	USHORT FileVersionNo = 200; // 200 for DM10b

	// writing header and file version number
	sprintf(TempBuf, "L3DT");
	fwrite(TempBuf, 4, 1, fh);
	fwrite((void*)&FileVersionNo, 2, 1, fh);

	// writing file header
	FH_DM.nx = (USHORT)nx;
	FH_DM.ny = (USHORT)ny;
	FH_DM.WrapFlag = theAPI.map_GetWrapFlag(hMap);
	
	// writing file header
	fwrite(&FH_DM.nx, 2, 1, fh);
	fwrite(&FH_DM.ny, 2, 1, fh);
	fwrite(&FH_DM.WrapFlag, 1, 1, fh);

	// writing data
	for(k=0; k<nx * ny; k++) {

		if(hProgWnd) {
			if(q==qstep)	{ p++; q=0; }
			if(q++==0) {
				PeekMessage(&TempMSG, NULL, 0, 0, PM_REMOVE);
				theAPI.progbox_SetProgress(hProgWnd, p, pmax);
			}
		}
		
		if(!theAPI.map_GetPixel(hMap, k%nx, k/nx, &DMpxl)) {
			theAPI.ReportError("CL3DTio_DMFApp::SaveDMF error\r\n - GetPixel returned false");
			fclose(fh);
			return false;
		}

		memcpy(CharBuf, &DMpxl.Alt, 2);
		memcpy(CharBuf+2, &DMpxl.Peak, 1);
		memcpy(CharBuf+3, &DMpxl.Frac, 1);
		memcpy(CharBuf+4, &DMpxl.Cliffs, 1);
		memcpy(CharBuf+5, &DMpxl.Erosion, 1);
		memcpy(CharBuf+6, &DMpxl.Lakes, 1);
		memcpy(CharBuf+7, &DMpxl.Climate, 1);
		memcpy(CharBuf+8, &DMpxl.SpecType, 1);
		memcpy(CharBuf+9, &DMpxl.SpecParam, 1);
					
		fwrite(CharBuf, 10, 1, fh);
	}


	fclose(fh);

	if(hProgWnd) {
		theAPI.progbox_HideWnd(hProgWnd);
	}

	return true;
}

bool CL3DTio_DMFApp::LoadMapFile(ZMAP hMap, LPCSTR lpFileName, long MapTypeID, ZFORMAT hFormat, ZVAR hProgWnd) {

	// check the map type
	switch(theAPI.map_GetMapType(hMap)) {
	default:
		theAPI.ReportError("CL3DTio_DMFApp::LoadMapFile error:\r\n - unsupported map type");
		return false;
	case 0: // auto, pluugin chooses
	case MAP_DesignMap:
		// OK
		break;
	}


	struct _iobuf *fh;
	int k;
	char TempBuf[10];
	CString TempStr;
	DesignMapPixel DMpxl;
	FileHeader_DMF FH_DM;
	USHORT FileVersionNo;
	char CharBuf[10];

	// opening file for reading
	fh=fopen(lpFileName, "rb"); 
	if(fh==NULL) {
		TempStr.Format("CL3DTio_DMFApp::LoadMapFile error:\r\n - File '%s' not found", lpFileName);
		theAPI.ReportError(TempStr);
		return false;
	}

	// interpreting header
	fread(TempBuf, 2, 1, fh);
	TempBuf[2]='\0';
	if(strcmp(TempBuf, "L3")!=0) {
		// case for old maps that didn't have "L3DT" written at start
		memcpy(&FileVersionNo, TempBuf, 2);
	} else {
		// case for 'new' L3DT maps
		fread(TempBuf, 4, 1, fh);
		memcpy(&FileVersionNo, TempBuf+2, 2);
	}

	switch(FileVersionNo) {
	default:
		theAPI.ReportError("CMapGroup::LoadDMF error\n - unknown file version");
		fclose(fh);
		return false;
	case 200: // this is DM10b
		// OK, this is supported (older versions have different ID's and aren't supproted)
		break;
	}

	// reading header
	fread(&FH_DM.nx, 2, 1, fh);
	fread(&FH_DM.ny, 2, 1, fh);
	fread(&FH_DM.WrapFlag, 1, 1, fh);

	long nx = (long)FH_DM.nx;
	long ny = (long)FH_DM.ny;

	if(nx<=0||ny<=0) {
		theAPI.ReportError("CL3DTio_DMFApp::LoadMapFile error\r\n - invalid map size");
		return false;
	}

	///////////////
	//
	// horiz scale is currently nominal (needs to be read from file)
	//
	///////////////

	if(!theAPI.map_Init(hMap, nx, ny, MAP_DesignMap, 1.0, (bool)FH_DM.WrapFlag)) {
		theAPI.ReportError("CL3DTio_DMFApp::LoadMapFile error:\r\n - Cannot initialise map");
		fclose(fh);
		return false;
	}
	
	// preparing progress bar
	__int64 p, q, pmax, qstep;
	MSG TempMSG;
	if(hProgWnd) {
		theAPI.progbox_SetTitle(hProgWnd, "Saving DMF");
		theAPI.progbox_ShowWnd(hProgWnd);
		pmax = nx * ny;
		qstep = (__int64)pmax/50; // HACK!
		if(qstep<1)	qstep=1;
		else 		pmax=50;
		q=0, p=0;
	}

	// reading data
	for(k=0; k<nx * ny; k++) {

		if(hProgWnd) {
			if(q==qstep)	{ p++; q=0; }
			if(q++==0) {
				PeekMessage(&TempMSG, NULL, 0, 0, PM_REMOVE);
				theAPI.progbox_SetProgress(hProgWnd, p, pmax);
			}
		}
		
		fread(CharBuf, 10, 1, fh);
		memcpy(&DMpxl.Alt, CharBuf, 2);
		memcpy(&DMpxl.Peak, CharBuf+2, 1);
		memcpy(&DMpxl.Frac, CharBuf+3, 1);
		memcpy(&DMpxl.Cliffs, CharBuf+4, 1);
		memcpy(&DMpxl.Erosion, CharBuf+5, 1);
		memcpy(&DMpxl.Lakes, CharBuf+6, 1);
		memcpy(&DMpxl.Climate, CharBuf+7, 1);
		memcpy(&DMpxl.SpecType, CharBuf+8, 1);
		memcpy(&DMpxl.SpecParam, CharBuf+9, 1);
		
		if(!theAPI.map_SetPixel(hMap, k%nx, k/nx, &DMpxl)) {
			theAPI.ReportError("CL3DTio_DMFApp::SaveDMF error\r\n - SetPixel returned false");
			fclose(fh);
			return false;
		}
	}

	fclose(fh);

	if(hProgWnd) {
		theAPI.progbox_HideWnd(hProgWnd);
	}

	return true;
}