// L3DTio_HFF.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "L3DTio_HFF.h"


#include "..\Plugin API\ExtAPI.h"
extern CExtAPI theAPI;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

// CL3DTio_HFFApp

BEGIN_MESSAGE_MAP(CL3DTio_HFFApp, CWinApp)
END_MESSAGE_MAP()


// CL3DTio_HFFApp construction

CL3DTio_HFFApp::CL3DTio_HFFApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CL3DTio_HFFApp object

CL3DTio_HFFApp theApp;


// CL3DTio_HFFApp initialization

BOOL CL3DTio_HFFApp::InitInstance() {
	CWinApp::InitInstance();

	return TRUE;
}

bool __stdcall ExtInitPlugin(FARPROC pFunc, LPVOID hID) {
	return theApp.InitPlugin(pFunc, hID);
}
bool __stdcall ExtSaveMapFile(ZMAP hMap, LPCSTR lpFileName, ZFORMAT hFormat, ZVAR hProgWnd) {
	return theApp.SaveMapFile(hMap, lpFileName, hFormat, hProgWnd);
}
bool __stdcall ExtLoadMapFile(ZMAP hMap, LPCSTR lpFileName, long MapTypeID, ZFORMAT hFormat, ZVAR hProgWnd) {
	return theApp.LoadMapFile(hMap, lpFileName, MapTypeID, hFormat, hProgWnd);
}
bool __stdcall ExtSaveTileFile(ZMAP hMap, LPVOID hTile, LPCSTR lpFileName, ZFORMAT hFormat) {
	return theApp.SaveTileFile(hMap, hTile, lpFileName, hFormat);
}
bool __stdcall ExtLoadTileFile(ZMAP hMap, LPVOID hTile, LPCSTR lpFileName, ZFORMAT hFormat) {
	return theApp.LoadTileFile(hMap, hTile, lpFileName, hFormat);
}

bool CL3DTio_HFFApp::InitPlugin(FARPROC pFunc, LPVOID hID) {

	// initalise the API
	if(!theAPI.InitAPI(pFunc, hID)) {
		AfxMessageBox("CL3DTio_HFFApp::InitPlugin error:\r\n - cannot load L3DT functions");
		return false;
	}

	//
	// add any further initialisation here
	//

	ZFORMAT hFormat;

	// heightfield
	hFormat = theAPI.format_Create("Heightfield", "L3DT Heightfield File", "hff", "L3DT");
	if(!hFormat) {
		// do nothing; this probably means the format already exists.
	} else {

		// set the flags
		theAPI.format_SetFlags(hFormat, true, true); // native I/O and mosaic

		// set the options
		int DataSize = 2;
		bool FloatFlag = false;
		int BlockSize = 0;
		theAPI.format_SetOptionValue(hFormat, "DataSize", VarID_int, &DataSize);
		theAPI.format_SetOptionValue(hFormat, "TileSize", VarID_int, &BlockSize);
		theAPI.format_SetOptionValue(hFormat, "FloatFlag", VarID_bool, &FloatFlag);
	}

	// water map
	hFormat = theAPI.format_Create("Water map", "L3DT Heightfield File", "hff", "L3DT");
	if(!hFormat) {
		// do nothing; this probably means the format already exists.
	} else {

		// set the flags
		theAPI.format_SetFlags(hFormat, false, false); // non-native I/O and non-mosaic too

		// set the options
		int DataSize = 2;
		bool FloatFlag = false;
		int BlockSize = 0;
		theAPI.format_SetOptionValue(hFormat, "DataSize", VarID_int, &DataSize);
		theAPI.format_SetOptionValue(hFormat, "TileSize", VarID_int, &BlockSize);
		theAPI.format_SetOptionValue(hFormat, "FloatFlag", VarID_bool, &FloatFlag);
	}

	// salinity map
	hFormat = theAPI.format_Create("Salinity map", "L3DT Heightfield File", "hff", "L3DT");
	if(!hFormat) {
		// do nothing; this probably means the format already exists.
	} else {

		// set the flags
		theAPI.format_SetFlags(hFormat, true, true); // native I/O and mosaic

		// set the options
		int DataSize = 1;
		bool FloatFlag = false;
		int BlockSize = 0;
		theAPI.format_SetOptionValue(hFormat, "DataSize", VarID_int, &DataSize);
		theAPI.format_SetOptionValue(hFormat, "TileSize", VarID_int, &BlockSize);
		theAPI.format_SetOptionValue(hFormat, "FloatFlag", VarID_bool, &FloatFlag);
	}

	return true;
}

bool CL3DTio_HFFApp::SaveMapFile(ZMAP hMap, LPCSTR lpFileName, ZFORMAT hFormat, ZVAR hProgWnd) {
	
	struct _iobuf *fh;
	int i, j, tx, ty;
	char TempBuf[10];
	USHORT TempUSI;
	int TempInt;
	CString TempStr;
	float TempFloat;
	BYTE TempByte;
	float HFpxl;
	float HFmin, HFmax;
	WaterMapPixel WMpxl;

	// check the map type
	switch(theAPI.map_GetMapType(hMap)) {
	default:
		theAPI.ReportError("CL3DTio_HFFApp::SaveMapFile error:\r\n - unsupported map type");
		return false;
	case MAP_Heightfield:
	case MAP_WaterMap:
		// OK
		break;
	}
	
	// get the altitude range
	if(!theAPI.map_GetMinMaxAlt(hMap, HFmin, HFmax)) {
		theAPI.ReportError("CL3DTio_HFFApp::SaveMapFile error:\r\n - call to GetMinMaxAlt failed");
		return false;
	}


	 // the file version number for HFF v1.0
	int FileVersionNo = DEF_FILE_HF300;

	// defaults
	int DataSize = 2;
	bool FloatFlag = false;
	int BlockSize = 0;
	theAPI.format_GetOptionValue(hFormat, "DataSize", VarID_int, &DataSize);
	theAPI.format_GetOptionValue(hFormat, "TileSize", VarID_int, &BlockSize);
	theAPI.format_GetOptionValue(hFormat, "FloatFlag", VarID_bool, &FloatFlag);

	long nx = theAPI.map_GetWidth(hMap);
	long ny = theAPI.map_GetHeight(hMap);

	if(nx<=0 || ny<=0) {
		theAPI.ReportError("CL3DTio_HFFApp::SaveMapFile error:\r\n - map not initialised");
		return false;
	}
	
	// making file header
	FileHeader_HF300 FH_HF300;
	FH_HF300.nx = nx;
	FH_HF300.ny = ny;
	FH_HF300.TileSize = BlockSize;
	FH_HF300.WrapFlag = theAPI.map_GetWrapFlag(hMap);
	FH_HF300.DataOffset = 64;			// 64 for HFF_v1.0
	FH_HF300.DataSize = DataSize;
	FH_HF300.FloatFlag = FloatFlag;
	FH_HF300.HorizScale = theAPI.map_GetHorizScale(hMap);

	if(FH_HF300.FloatFlag) {
		switch(FH_HF300.DataSize) {
		case 4:
			FH_HF300.VertScale = 1.0f;
			FH_HF300.VertOffset = 0.0f;
			break;
		default:
			theAPI.ReportError("CL3DTio_HFFApp::SaveMapFile error:\r\n - unacceptable data size in HFFv1.0 (float)");
			return false;
		}
	} else {
		switch(FH_HF300.DataSize) {
		case 1:
			FH_HF300.VertScale = (float)(HFmax - HFmin)/255.0f;
			FH_HF300.VertOffset = HFmin;
			break;
		case 2: // USHORT
			FH_HF300.VertScale=(float)(HFmax - HFmin)/65535.0f;
			FH_HF300.VertOffset = HFmin;
			break;
		default:
			theAPI.ReportError("CL3DTio_HFFApp::SaveMapFile error:\r\n - unacceptable data size in HFFv1.0 (int)");
			return false;
		}
	}

	if(FH_HF300.TileSize>1) {
		if(FH_HF300.nx%FH_HF300.TileSize!=0 || FH_HF300.ny%FH_HF300.TileSize!=0) {
			theAPI.ReportError("CL3DTio_HFFApp::SaveMapFile error:\r\n - tile size is incompatible with map size in HFFv1.0");
			return false;
		}
	}
	
	// opening file for writing
	fh=fopen(lpFileName, "wb"); 
	if(fh==NULL) {
		theAPI.ReportError("CL3DTio_HFFApp::SaveMapFile error:\r\n - cannot open file for writing");
		return false;
	}

	// writing header
	sprintf(TempBuf, "L3DT");
	fwrite(TempBuf, 4, 1, fh);
	fwrite((void*)&FileVersionNo, 2, 1, fh);
	sprintf(TempBuf, "HFF_v1.0");
	fwrite(TempBuf, 8, 1, fh);
	fwrite(&FH_HF300.DataOffset, 2, 1, fh);
	fwrite(&FH_HF300.nx, 4, 1, fh);
	fwrite(&FH_HF300.ny, 4, 1, fh);
	fwrite(&FH_HF300.DataSize, 1, 1, fh);
	fwrite(&FH_HF300.FloatFlag, 1, 1, fh);
	fwrite(&FH_HF300.VertScale, 4, 1, fh);
	fwrite(&FH_HF300.VertOffset, 4, 1, fh);
	fwrite(&FH_HF300.HorizScale, 4, 1, fh);
	fwrite(&FH_HF300.TileSize, 2, 1, fh);
	fwrite(&FH_HF300.WrapFlag, 1, 1, fh);
	TempBuf[0]=0;
	fwrite(TempBuf, 1, 23, fh);	// filling in reserved junk
	
	// preparing progress bar
	__int64 p, q, pmax, qstep;
	MSG TempMSG;
	if(hProgWnd) {
		theAPI.progbox_SetTitle(hProgWnd, "Saving HFF");
		theAPI.progbox_ShowWnd(hProgWnd);
		pmax = (__int64)nx * (__int64)ny;
		qstep = (__int64)pmax/50; // HACK!
		if(qstep<1)	qstep=1;
		else 		pmax=50;
		q=0, p=0;
	}


	int TempTileSize = FH_HF300.TileSize;
	if(TempTileSize<1)
		TempTileSize = 1;
	
	bool ErrorFlag = false;

	int nty = ny / TempTileSize;
	int ntx = nx / TempTileSize;
	if(ny%TempTileSize)	nty++;
	if(nx%TempTileSize)	ntx++;

	int i2, j2;

	for(ty=0; ty<nty && !ErrorFlag; ty++) {
	for(tx=0; tx<ntx && !ErrorFlag; tx++) {
		for(j=0; j<TempTileSize && !ErrorFlag; j++) {
		for(i=0; i<TempTileSize && !ErrorFlag; i++) {

			i2 = i + tx*TempTileSize;
			j2 = j + ty*TempTileSize;

			if(i2<nx && j2<ny) {

				if(hProgWnd) {
					if(q==qstep)	{ p++; q=0; }
					if(q++==0) {
						PeekMessage(&TempMSG, NULL, 0, 0, PM_REMOVE);
						theAPI.progbox_SetProgress(hProgWnd, p, pmax);
					}
				}

				switch(theAPI.map_GetMapType(hMap)) {
				case MAP_Heightfield:
					if(!theAPI.map_GetPixel(hMap, i2, j2, &HFpxl)) {
						theAPI.ReportError("CL3DTio_HFFApp::SaveMapFile error:\r\n - GetPixel returned false from HF");
						ErrorFlag = true;
					}
					break;
				case MAP_WaterMap:
					if(!theAPI.map_GetPixel(hMap, i2, j2, &WMpxl)) {
						theAPI.ReportError("CL3DTio_HFFApp::SaveMapFile error:\r\n - GetPixel returned false from WM");
						ErrorFlag = true;
					}
					HFpxl = WMpxl.WaterLevel;
					break;
				}

				if(!ErrorFlag) {
					if(FH_HF300.FloatFlag) {
						TempFloat=(HFpxl - FH_HF300.VertOffset)/FH_HF300.VertScale; // note gain & offset are taken into account when saving floats
						fwrite((void*)&TempFloat, 4, 1, fh);
					} else {
						switch(FH_HF300.DataSize) {
						case 1:
							TempInt=(int)((HFpxl-FH_HF300.VertOffset)/FH_HF300.VertScale);
							if(TempInt<0)		TempInt=0;
							if(TempInt>255)		TempInt=255;
							TempByte=(BYTE)TempInt;
							fwrite((void*)&TempByte, 1, 1, fh);
							break;
						case 2:
							TempInt=(int)((HFpxl-FH_HF300.VertOffset)/FH_HF300.VertScale);
							if(TempInt<0)		TempInt=0;
							if(TempInt>65535)	TempInt=65535;
							TempUSI=(USHORT)TempInt;
							fwrite((void*)&TempUSI, 2, 1, fh);
							break;
						default:
							theAPI.ReportError("CL3DTio_HFFApp::SaveMapFile error\r\n - pixel size is invalid");
							ErrorFlag = true;
							break;
						}
					}
				}
			}
		}
		}
	}
	}

	if(hProgWnd) {
		theAPI.progbox_HideWnd(hProgWnd);
	}

	fclose(fh);

	if(ErrorFlag) {
		theAPI.ReportError("CL3DTio_HFFApp::SaveMapFile error:\r\n - Save terminated following errors");
		return false;
	}
	
	return true;
}

bool CL3DTio_HFFApp::LoadMapFile(ZMAP hMap, LPCSTR lpFileName, long MapTypeID, ZFORMAT hFormat, ZVAR hProgWnd) {
	
	struct _iobuf *fh;
	int i, j, tx, ty, i2, j2;
	char TempBuf[8];
	USHORT TempUSI;
	float TempFloat;
	CString TempStr;
	BYTE TempByte;
	char FileVersionCharBuf[9];
	char* CharBuf;


	USHORT FileVersionNo;

	// opening file for reading
	fh=fopen(lpFileName, "rb"); 
	if(fh==NULL) {
		TempStr.Format("File '%s' not found", lpFileName);
		theAPI.ReportError(TempStr);
		return false;
	}

	// check the file header
	fread(TempBuf, 4, 1, fh);
	TempBuf[4] = 0; 	// null-terminating string
	if(strcmp(TempBuf, "L3DT")!=0) {
		// case for old maps that didn't have "L3DT" written at start
		theAPI.ReportError("CL3DTio_HFFApp::LoadMapFile error\r\n - invalid file type");
		fclose(fh);
		return false;
	}
		
	// read the file version number
	fread(&FileVersionNo, 2, 1, fh);
	switch(FileVersionNo) {
	default:
		theAPI.ReportError("CL3DTio_HFFApp::LoadMapFile error\r\n - unknown file version");
		fclose(fh);
		return false;
	case DEF_FILE_HF300:
		//this is OK
		break;
	}

	// reading ASCII external file version number
	fread(FileVersionCharBuf, 8, 1, fh);
	FileVersionCharBuf[8]=0;	// null-terminating string
	if(strcmp(FileVersionCharBuf, "HFF_v1.0")!=0) {
		TempStr.Format("CL3DTio_HFFApp::LoadMapFile error\r\n - unknown file version '%s' in HF300", FileVersionCharBuf);
		theAPI.ReportError(TempStr);
		fclose(fh);
		return false;
	}

	// declare a file header struct
	FileHeader_HF300 FH_HF300;

	// read the data offset
	fread(&FH_HF300.DataOffset, 2, 1, fh);

	// check data offset
	if(FH_HF300.DataOffset<64) {
		theAPI.ReportError("CL3DTio_HFFApp::LoadMapFile error:\r\n - Invalid file header length");
		fclose(fh);
		return false;
	}

	// reading remainder of header into char buffer
	CharBuf=(char*)calloc(1, FH_HF300.DataOffset-16);
	fread(CharBuf, FH_HF300.DataOffset-16, 1, fh);

	// copy from buffer into header struct
	memcpy(&FH_HF300.nx, CharBuf, 4);
	memcpy(&FH_HF300.ny, CharBuf+4, 4);
	memcpy(&FH_HF300.DataSize, CharBuf+8, 1);
	memcpy(&FH_HF300.FloatFlag, CharBuf+9, 1);
	memcpy(&FH_HF300.VertScale, CharBuf+10, 4);
	memcpy(&FH_HF300.VertOffset, CharBuf+14, 4);
	memcpy(&FH_HF300.HorizScale, CharBuf+18, 4);
	memcpy(&FH_HF300.TileSize, CharBuf+22, 2);
	memcpy(&FH_HF300.WrapFlag, CharBuf+24, 1);

	// free buffer
	free(CharBuf);

	// check tiling (is it compatible with map size?)
	if(FH_HF300.TileSize>1) {
		if(FH_HF300.nx%FH_HF300.TileSize!=0 || FH_HF300.ny%FH_HF300.TileSize!=0) {
			theAPI.ReportError("CL3DTio_HFFApp::LoadMapFile error\r\n - tile size is incompatible with map size in HF300");
			fclose(fh);
			return false;
		}
	}

	// check vertical scaling
	if(FH_HF300.VertScale<=0.0) {
		theAPI.ReportError("CL3DTio_HFFApp::LoadMapFile error\r\n - vertical scale is equal to or smaller than zero");
		fclose(fh);
		return false;
	}

	// check horizontal scaling
	if(FH_HF300.HorizScale<=0.0) {
		theAPI.ReportError("CL3DTio_HFFApp::LoadMapFile error\r\n - horizontal scale is equal to or smaller than zero");
		fclose(fh);
		return false;
	}

	// checking data types
	if(FH_HF300.FloatFlag) {
		switch(FH_HF300.DataSize) {
		case 4:	// that's OK
			break;
		default:
			theAPI.ReportError("CL3DTio_HFFApp::LoadMapFile error\r\n - unacceptable data size (float)");
			fclose(fh);
			return false;
		}
	} else {
		switch(FH_HF300.DataSize) {
		case 1: // BYTE is OK
			break;
		case 2: // USHORT is OK
			break;
		default:
			theAPI.ReportError("CL3DTio_HFFApp::LoadMapFile error\r\n - unacceptable data size (int)");
			fclose(fh);
			return false;
		}
	}

	// freeing map memory if already allocated
	if(theAPI.map_GetMapType(hMap)!=MAP_Empty)
		theAPI.map_Free(hMap);

	long nx = FH_HF300.nx;
	long ny = FH_HF300.ny;

	if(nx<=0||ny<=0) {
		theAPI.ReportError("CL3DTio_HFFApp::LoadMapFile error\r\n - invalid map size");
		fclose(fh);
		return false;
	}

	// initialising map
	if(!theAPI.map_Init(hMap, nx, ny, MAP_Heightfield, FH_HF300.HorizScale, (bool)FH_HF300.WrapFlag)) {
		theAPI.ReportError("CL3DTio_HFFApp::LoadMapFile error\r\n - cannot initialise map");
		fclose(fh);
		return false;
	}

	// preparing progress bar
	__int64 p, q, pmax, qstep;
	MSG TempMSG;
	if(hProgWnd) {
		theAPI.progbox_SetTitle(hProgWnd, "Loading HFF");
		theAPI.progbox_ShowWnd(hProgWnd);
		pmax = nx * ny;
		qstep = (__int64)pmax/50; // HACK!
		if(qstep<1)	qstep=1;
		else 		pmax=50;
		q=0, p=0;
	}

	// reading data (handling both tiled and non-tiled maps)
	int TileSize = FH_HF300.TileSize;
	if(TileSize<=0)	TileSize = 1;

	// stepping through tiles
	bool ErrorFlag = false;
	for(ty=0; ty<ny/TileSize && !ErrorFlag; ty++) {
	for(tx=0; tx<nx/TileSize && !ErrorFlag; tx++) {

		// stepping through pixels in each tile
		for(j=0; j<TileSize && !ErrorFlag; j++) {
		for(i=0; i<TileSize && !ErrorFlag; i++) {

			// converting from local tile coords to global map coords
			i2 = i+tx*TileSize;
			j2 = j+ty*TileSize;

			if(i2<nx && j2<ny) {

				if(hProgWnd) {
					if(q==qstep)	{ p++; q=0; }
					if(q++==0) {
						PeekMessage(&TempMSG, NULL, 0, 0, PM_REMOVE);
						theAPI.progbox_SetProgress(hProgWnd, p, pmax);
					}
				}

				if(FH_HF300.FloatFlag) {
					fread((void*)&TempFloat, 4, 1, fh);
					TempFloat = TempFloat*FH_HF300.VertScale+FH_HF300.VertOffset;
				} else {
					switch(FH_HF300.DataSize) {
					case 1:
						fread((void*)&TempByte, 1, 1, fh);
						TempFloat = (float)TempByte*FH_HF300.VertScale+FH_HF300.VertOffset;
						break;	
					case 2:
						fread((void*)&TempUSI, 2, 1, fh);
						TempFloat = (float)TempUSI*FH_HF300.VertScale+FH_HF300.VertOffset;
						break;
					default:
						ErrorFlag = true;
						theAPI.ReportError("CL3DTio_HFFApp::LoadMapFile error\n - pixel size is invalid in HF300");
						break;
					}
				}

				if(!theAPI.map_SetPixel(hMap, i2, j2, &TempFloat)) {
					ErrorFlag = true;
					theAPI.ReportError("CL3DTio_HFFApp::LoadMapFile error\n - call to SetPixel failed");
				}
			}
		}
		}
	}
	}

	fclose(fh);

	if(hProgWnd) {
		theAPI.progbox_HideWnd(hProgWnd);
	}

	if(ErrorFlag) {
		return false;
	}

	// updating file config	
	int datasize = FH_HF300.DataSize;
	int tilesize = FH_HF300.TileSize;
	bool floatflag = FH_HF300.FloatFlag;
	theAPI.format_SetOptionValue(hFormat, "DataSize", VarID_int, &datasize);
	theAPI.format_SetOptionValue(hFormat, "TileSize", VarID_int, &tilesize);
	theAPI.format_SetOptionValue(hFormat, "FloatFlag", VarID_bool, &floatflag);

	return true;
}

bool CL3DTio_HFFApp::SaveTileFile(ZMAP hMap, LPVOID hTile, LPCSTR lpFileName, ZFORMAT hFormat) {
	
	struct _iobuf *fh;
	int i, j, tx, ty;
	char TempBuf[10];
	USHORT TempUSI;
	int TempInt;
	CString TempStr;
	float TempFloat;
	BYTE TempByte;
	float HFpxl;
	float HFmin, HFmax;

	// check the map type
	switch(theAPI.map_GetMapType(hMap)) {
	default:
		theAPI.ReportError("CL3DTio_HFFApp::SaveTileFile error:\r\n - unsupported map type");
		return false;
	case MAP_Heightfield:
		// OK
		break;
	}
	
	// get the altitude range
	if(!theAPI.tile_GetMinMaxAlt(hTile, HFmin, HFmax)) {
		theAPI.ReportError("CL3DTio_HFFApp::SaveTileFile error:\r\n - call to tile_GetMinMaxAlt failed");
		return false;
	}


	 // the file version number for HFF v1.0
	int FileVersionNo = DEF_FILE_HF300;

	// defaults
	int DataSize = 2;
	bool FloatFlag = false;
	int BlockSize = 0;
	theAPI.format_GetOptionValue(hFormat, "DataSize", VarID_int, &DataSize);
	theAPI.format_GetOptionValue(hFormat, "TileSize", VarID_int, &BlockSize);
	theAPI.format_GetOptionValue(hFormat, "FloatFlag", VarID_bool, &FloatFlag);

	long nx, ny;
	nx = ny = theAPI.map_GetMosaicTileSize(hMap);

	if(nx<=0 || ny<=0) {
		theAPI.ReportError("CL3DTio_HFFApp::SaveTileFile error:\r\n - invalid tile size");
		return false;
	}
	
	// making file header
	FileHeader_HF300 FH_HF300;
	FH_HF300.nx = nx;
	FH_HF300.ny = ny;
	FH_HF300.TileSize = BlockSize;
	FH_HF300.WrapFlag = theAPI.map_GetWrapFlag(hMap);
	FH_HF300.DataOffset = 64;			// 64 for HFF_v1.0
	FH_HF300.DataSize = DataSize;
	FH_HF300.FloatFlag = FloatFlag;
	FH_HF300.HorizScale = theAPI.map_GetHorizScale(hMap);

	if(FH_HF300.FloatFlag) {
		switch(FH_HF300.DataSize) {
		case 4:
			FH_HF300.VertScale = 1.0f;
			FH_HF300.VertOffset = 0.0f;
			break;
		default:
			theAPI.ReportError("CL3DTio_HFFApp::SaveTileFile error:\r\n - unacceptable data size in HFFv1.0 (float)");
			return false;
		}
	} else {
		switch(FH_HF300.DataSize) {
		case 1:
			FH_HF300.VertScale = (float)(HFmax - HFmin)/255.0f;
			FH_HF300.VertOffset = HFmin;
			break;
		case 2: // USHORT
			FH_HF300.VertScale=(float)(HFmax - HFmin)/65535.0f;
			FH_HF300.VertOffset = HFmin;
			break;
		default:
			theAPI.ReportError("CL3DTio_HFFApp::SaveTileFile error:\r\n - unacceptable data size in HFFv1.0 (int)");
			return false;
		}
	}

	if(FH_HF300.VertScale<=0.0f) {
		theAPI.ReportError("CL3DTio_HFFApp::SaveTileFile error:\r\n - vert scale is invalid");
		return false;
	}

	if(FH_HF300.TileSize>1) {
		if(FH_HF300.nx%FH_HF300.TileSize!=0 || FH_HF300.ny%FH_HF300.TileSize!=0) {
			theAPI.ReportError("CL3DTio_HFFApp::SaveTileFile error:\r\n - tile size is incompatible with map size in HFFv1.0");
			return false;
		}
	}
	
	// opening file for writing
	fh=fopen(lpFileName, "wb"); 
	if(fh==NULL) {
		TempStr.Format("CL3DTio_HFFApp::SaveTileFile error:\r\n - cannot open file '%s' for writing", lpFileName);
		theAPI.ReportError(TempStr);
		return false;
	}

	// writing header
	sprintf(TempBuf, "L3DT");
	fwrite(TempBuf, 4, 1, fh);
	fwrite((void*)&FileVersionNo, 2, 1, fh);
	sprintf(TempBuf, "HFF_v1.0");
	fwrite(TempBuf, 8, 1, fh);
	fwrite(&FH_HF300.DataOffset, 2, 1, fh);
	fwrite(&FH_HF300.nx, 4, 1, fh);
	fwrite(&FH_HF300.ny, 4, 1, fh);
	fwrite(&FH_HF300.DataSize, 1, 1, fh);
	fwrite(&FH_HF300.FloatFlag, 1, 1, fh);
	fwrite(&FH_HF300.VertScale, 4, 1, fh);
	fwrite(&FH_HF300.VertOffset, 4, 1, fh);
	fwrite(&FH_HF300.HorizScale, 4, 1, fh);
	fwrite(&FH_HF300.TileSize, 2, 1, fh);
	fwrite(&FH_HF300.WrapFlag, 1, 1, fh);
	TempBuf[0]=0;
	fwrite(TempBuf, 1, 23, fh);	// filling in reserved junk

	int TempTileSize = FH_HF300.TileSize;
	if(TempTileSize<1)
		TempTileSize = 1;
	
	bool ErrorFlag = false;

	int nty = ny / TempTileSize;
	int ntx = nx / TempTileSize;
	if(ny%TempTileSize)	nty++;
	if(nx%TempTileSize)	ntx++;

	for(ty=0; ty<nty && !ErrorFlag; ty++) {
	for(tx=0; tx<ntx && !ErrorFlag; tx++) {
		for(j=ty*TempTileSize; j<(ty+1)*TempTileSize && j<ny && !ErrorFlag; j++) {
		for(i=tx*TempTileSize; i<(tx+1)*TempTileSize && i<nx && !ErrorFlag; i++) {

			switch(theAPI.map_GetMapType(hMap)) {
			default:
				ErrorFlag = true;
				break;
			case MAP_Heightfield:
				if(!theAPI.tile_GetPixel(hTile, i, j, &HFpxl)) {
					theAPI.ReportError("CL3DTio_HFFApp::TileMapFile error:\r\n - GetPixel returned false for HF");
					ErrorFlag = true;
				}
				break;
			}

			if(!ErrorFlag) {
				if(FH_HF300.FloatFlag) {
					TempFloat=(HFpxl - FH_HF300.VertOffset)/FH_HF300.VertScale; // note gain & offset are taken into account when saving floats
					fwrite((void*)&TempFloat, 4, 1, fh);
				} else {
					switch(FH_HF300.DataSize) {
					case 1:
						TempInt=(int)((HFpxl-FH_HF300.VertOffset)/FH_HF300.VertScale);
						if(TempInt<0)		TempInt=0;
						if(TempInt>255)		TempInt=255;
						TempByte=(BYTE)TempInt;
						fwrite((void*)&TempByte, 1, 1, fh);
						break;
					case 2:
						TempInt=(int)((HFpxl-FH_HF300.VertOffset)/FH_HF300.VertScale);
						if(TempInt<0)		TempInt=0;
						if(TempInt>65535)	TempInt=65535;
						TempUSI=(USHORT)TempInt;
						fwrite((void*)&TempUSI, 2, 1, fh);
						break;
					default:
						theAPI.ReportError("CL3DTio_HFFApp::SaveTileFile error\r\n - pixel size is invalid");
						ErrorFlag = true;
						break;
					}
				}
			}
		}
		}
	}
	}


	fclose(fh);

	if(ErrorFlag) {
		theAPI.ReportError("CL3DTio_HFFApp::SaveTileFile error:\r\n - Save terminated following errors");
		return false;
	}
	
	return true;
}
bool CL3DTio_HFFApp::LoadTileFile(ZMAP hMap, LPVOID hTile, LPCSTR lpFileName, ZFORMAT hFormat) {
	
	struct _iobuf *fh;
	int i, j, tx, ty, i2, j2;
	char TempBuf[8];
	USHORT TempUSI;
	float TempFloat;
	CString TempStr;
	BYTE TempByte;
	char FileVersionCharBuf[9];
	char* CharBuf;


	USHORT FileVersionNo;

	// opening file for reading
	fh=fopen(lpFileName, "rb"); 
	if(fh==NULL) {
		TempStr.Format("CL3DTio_HFFApp::LoadTileFile error\r\n - File '%s' not found fo reading", lpFileName);
		theAPI.ReportError(TempStr);
		return false;
	}

	// check the file header
	fread(TempBuf, 4, 1, fh);
	TempBuf[4] = 0; 	// null-terminating string
	if(strcmp(TempBuf, "L3DT")!=0) {
		// case for old maps that didn't have "L3DT" written at start
		theAPI.ReportError("CL3DTio_HFFApp::LoadTileFile error\r\n - invalid file type");
		fclose(fh);
		return false;
	}
		
	// read the file version number
	fread(&FileVersionNo, 2, 1, fh);
	switch(FileVersionNo) {
	default:
		theAPI.ReportError("CL3DTio_HFFApp::LoadTileFile error\r\n - unknown file version");
		fclose(fh);
		return false;
	case DEF_FILE_HF300:
		//this is OK
		break;
	}

	// reading ASCII external file version number
	fread(FileVersionCharBuf, 8, 1, fh);
	FileVersionCharBuf[8]=0;	// null-terminating string
	if(strcmp(FileVersionCharBuf, "HFF_v1.0")!=0) {
		TempStr.Format("CL3DTio_HFFApp::LoadTileFile error\r\n - unknown file version '%s' in HF300", FileVersionCharBuf);
		theAPI.ReportError(TempStr);
		fclose(fh);
		return false;
	}

	// declare a file header struct
	FileHeader_HF300 FH_HF300;

	// read the data offset
	fread(&FH_HF300.DataOffset, 2, 1, fh);

	// check data offset
	if(FH_HF300.DataOffset<64) {
		theAPI.ReportError("CL3DTio_HFFApp::LoadTileFile error:\r\n - Invalid file header length");
		fclose(fh);
		return false;
	}

	// reading remainder of header into char buffer
	CharBuf=(char*)calloc(1, FH_HF300.DataOffset-16);
	fread(CharBuf, FH_HF300.DataOffset-16, 1, fh);

	// copy from buffer into header struct
	memcpy(&FH_HF300.nx, CharBuf, 4);
	memcpy(&FH_HF300.ny, CharBuf+4, 4);
	memcpy(&FH_HF300.DataSize, CharBuf+8, 1);
	memcpy(&FH_HF300.FloatFlag, CharBuf+9, 1);
	memcpy(&FH_HF300.VertScale, CharBuf+10, 4);
	memcpy(&FH_HF300.VertOffset, CharBuf+14, 4);
	memcpy(&FH_HF300.HorizScale, CharBuf+18, 4);
	memcpy(&FH_HF300.TileSize, CharBuf+22, 2);
	memcpy(&FH_HF300.WrapFlag, CharBuf+24, 1);

	// free buffer
	free(CharBuf);

	// check tiling (is it compatible with map size?)
	if(FH_HF300.TileSize>1) {
		if(FH_HF300.nx%FH_HF300.TileSize!=0 || FH_HF300.ny%FH_HF300.TileSize!=0) {
			theAPI.ReportError("CL3DTio_HFFApp::LoadTileFile error\r\n - tile size is incompatible with map size in HF300");
			fclose(fh);
			return false;
		}
	}

	// check vertical scaling
	if(FH_HF300.VertScale<=0.0) {
		theAPI.ReportError("CL3DTio_HFFApp::LoadTileFile error\r\n - vertical scale is equal to or smaller than zero");
		fclose(fh);
		return false;
	}

	// check horizontal scaling
	if(FH_HF300.HorizScale<=0.0) {
		theAPI.ReportError("CL3DTio_HFFApp::LoadTileFile error\r\n - horizontal scale is equal to or smaller than zero");
		fclose(fh);
		return false;
	}

	// checking data types
	if(FH_HF300.FloatFlag) {
		switch(FH_HF300.DataSize) {
		case 4:	// that's OK
			break;
		default:
			theAPI.ReportError("CL3DTio_HFFApp::LoadTileFile error\r\n - unacceptable data size (float)");
			fclose(fh);
			return false;
		}
	} else {
		switch(FH_HF300.DataSize) {
		case 1: // BYTE is OK
			break;
		case 2: // USHORT is OK
			break;
		default:
			theAPI.ReportError("CL3DTio_HFFApp::LoadTileFile error\r\n - unacceptable data size (int)");
			fclose(fh);
			return false;
		}
	}

	long nx = FH_HF300.nx;
	long ny = FH_HF300.ny;

	if(nx<=0||ny<=0 || nx!=ny) {
		theAPI.ReportError("CL3DTio_HFFApp::LoadTileFile error\r\n - invalid map size");
		fclose(fh);
		return false;
	}

	if(nx!=theAPI.map_GetMosaicTileSize(hMap)) {
		theAPI.ReportError("CL3DTio_HFFApp::LoadTileFile error\r\n - file size does not match tile size");
		fclose(fh);
		return false;
	}


	// reading data (handling both tiled and non-tiled maps)
	int TileSize = FH_HF300.TileSize;
	if(TileSize<=0)	TileSize = 1;

	// stepping through tiles
	bool ErrorFlag = false;
	for(ty=0; ty<ny/TileSize && !ErrorFlag; ty++) {
	for(tx=0; tx<nx/TileSize && !ErrorFlag; tx++) {

		// stepping through pixels in each tile
		for(j=0; j<TileSize && !ErrorFlag; j++) {
		for(i=0; i<TileSize && !ErrorFlag; i++) {

			// converting from local tile coords to global map coords
			i2 = i+tx*TileSize;
			j2 = j+ty*TileSize;

			if(FH_HF300.FloatFlag) {
				fread((void*)&TempFloat, 4, 1, fh);
				TempFloat = TempFloat*FH_HF300.VertScale+FH_HF300.VertOffset;
			} else {
				switch(FH_HF300.DataSize) {
				case 1:
					fread((void*)&TempByte, 1, 1, fh);
					TempFloat = (float)TempByte*FH_HF300.VertScale+FH_HF300.VertOffset;
					break;	
				case 2:
					fread((void*)&TempUSI, 2, 1, fh);
					TempFloat = (float)TempUSI*FH_HF300.VertScale+FH_HF300.VertOffset;
					break;
				default:
					ErrorFlag = true;
					theAPI.ReportError("CL3DTio_HFFApp::LoadMapFile error\n - pixel size is invalid in HF300");
					break;
				}
			}

			if(!theAPI.tile_SetPixel(hTile, i2, j2, &TempFloat)) {
				ErrorFlag = true;
				theAPI.ReportError("CL3DTio_HFFApp::LoadTileFile error\n - call to SetPixel failed");
			}
		}
		}
	}
	}

	fclose(fh);

	if(ErrorFlag) {
		return false;
	}

	// updating file config	
	int datasize = FH_HF300.DataSize;
	int tilesize = FH_HF300.TileSize;
	bool floatflag = FH_HF300.FloatFlag;
	theAPI.format_SetOptionValue(hFormat, "DataSize", VarID_int, &datasize);
	theAPI.format_SetOptionValue(hFormat, "TileSize", VarID_int, &tilesize);
	theAPI.format_SetOptionValue(hFormat, "FloatFlag", VarID_bool, &floatflag);

	return true;
}