// L3DTio_HTF.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include "L3DTio_HTF.h"

#include "..\Plugin API\ExtAPI.h"
extern CExtAPI theAPI;

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

//
//	Note!
//
//		If this DLL is dynamically linked against the MFC
//		DLLs, any functions exported from this DLL which
//		call into MFC must have the AFX_MANAGE_STATE macro
//		added at the very beginning of the function.
//
//		For example:
//
//		extern "C" BOOL PASCAL EXPORT ExportedFunction()
//		{
//			AFX_MANAGE_STATE(AfxGetStaticModuleState());
//			// normal function body here
//		}
//
//		It is very important that this macro appear in each
//		function, prior to any calls into MFC.  This means that
//		it must appear as the first statement within the 
//		function, even before any object variable declarations
//		as their constructors may generate calls into the MFC
//		DLL.
//
//		Please see MFC Technical Notes 33 and 58 for additional
//		details.
//

// CL3DTio_HTFApp

BEGIN_MESSAGE_MAP(CL3DTio_HTFApp, CWinApp)
END_MESSAGE_MAP()


// CL3DTio_HTFApp construction

CL3DTio_HTFApp::CL3DTio_HTFApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}


// The one and only CL3DTio_HTFApp object

CL3DTio_HTFApp theApp;


// CL3DTio_HTFApp initialization

BOOL CL3DTio_HTFApp::InitInstance()
{
	CWinApp::InitInstance();

	return TRUE;
}

bool __stdcall ExtInitPlugin(FARPROC pFunc, LPVOID hID) {
	return theApp.InitPlugin(pFunc, hID);
}
bool __stdcall ExtSaveMapFile(ZMAP hMap, LPCSTR lpFileName, ZFORMAT hFormat, ZVAR hProgWnd) {
	return theApp.SaveMapFile(hMap, lpFileName, hFormat, hProgWnd);
}

bool CL3DTio_HTFApp::InitPlugin(FARPROC pFunc, LPVOID hID) {

	// initalise the API
	if(!theAPI.InitAPI(pFunc, hID)) {
		AfxMessageBox("CL3DTio_HTFApp::InitPlugin error:\r\n - cannot load L3DT functions");
		return false;
	}

	//
	// add any further initialisation here
	//

	// create my format
	ZFORMAT hFormat = theAPI.format_Create("Heightfield", "GLScene Height Tile File", "htf", "GLScene");
	if(!hFormat) {
		// do nothing; this probably means the format already exists.
	} else {

		// set the flags
		theAPI.format_SetFlags(hFormat, false, false); // native I/O and mosaic

		// set the options
		ZLIST hOptions = theAPI.format_GetOptionList(hFormat);
		if(!hOptions) {
			AfxMessageBox("CL3DTio_HTFApp::InitPlugin error:\r\n - cannot create options list");
			return false;
		}
		
		int TileSize = 64;
		bool Overlap = true;
		theAPI.format_SetOptionValue(hFormat, "TileSize", VarID_int, &TileSize);
		theAPI.format_SetOptionValue(hFormat, "Overlap", VarID_bool, &Overlap);
		
		ZVAR hComboSel;
/*		if(hComboSel = theAPI.list_CreateItem(hOptions, VarID_ComboSelector, "PackMode")) {
			theAPI.combosel_SetOptions("Raw|RLE|DIFF|Best");
			theAPI.combosel_SetCurSel("Raw");
		}*/
		if(hComboSel = theAPI.list_CreateItem(hOptions, VarID_ComboSelector, "FlipAxes")) {
			theAPI.combosel_SetOptions(hComboSel, "None|X-axis|Y-axis|Both");
			theAPI.combosel_SetCurSel(hComboSel, "Y-axis");
		}

		if(hComboSel = theAPI.list_CreateItem(hOptions, VarID_ComboSelector, "VertMode")) {
			theAPI.combosel_SetOptions(hComboSel, "Span 16-bit range|Clip to metres");
			theAPI.combosel_SetCurSel(hComboSel, "Clip to metres");
		}
	}


	// repeat for water map
	hFormat = theAPI.format_Create("Water map", "GLScene Height Tile File", "htf", "GLScene");
	if(!hFormat) {
		// do nothing; this probably means the format already exists.
	} else {

		// set the flags
		theAPI.format_SetFlags(hFormat, false, false); // native I/O and mosaic

		// set the options
		ZLIST hOptions = theAPI.format_GetOptionList(hFormat);
		if(!hOptions) {
			AfxMessageBox("CL3DTio_HTFApp::InitPlugin error:\r\n - cannot create options list");
			return false;
		}
		
		int TileSize = 64;
		bool Overlap = true;
		theAPI.format_SetOptionValue(hFormat, "TileSize", VarID_int, &TileSize);
		theAPI.format_SetOptionValue(hFormat, "Overlap", VarID_bool, &Overlap);
		
		ZVAR hComboSel;
/*		if(hComboSel = theAPI.list_CreateItem(hOptions, VarID_ComboSelector, "PackMode")) {
			theAPI.combosel_SetOptions("Raw|RLE|DIFF|Best");
			theAPI.combosel_SetCurSel("Raw");
		}*/
		if(hComboSel = theAPI.list_CreateItem(hOptions, VarID_ComboSelector, "FlipAxes")) {
			theAPI.combosel_SetOptions(hComboSel, "None|X-axis|Y-axis|Both");
			theAPI.combosel_SetCurSel(hComboSel, "Y-axis");
		}

		if(hComboSel = theAPI.list_CreateItem(hOptions, VarID_ComboSelector, "VertMode")) {
			theAPI.combosel_SetOptions(hComboSel, "Span 16-bit range|Clip to metres");
			theAPI.combosel_SetCurSel(hComboSel, "Clip to metres");
		}
	}

	return true;
}

bool CL3DTio_HTFApp::SaveMapFile(ZMAP hMap, LPCSTR lpFileName, ZFORMAT hFormat, ZVAR hProgWnd) {

	// check the map type
	long MapType = theAPI.map_GetMapType(hMap);
	switch(MapType) {
	default:
		theAPI.ReportError("CL3DTio_HTFApp::SaveMapFile error:\r\n - unsupported map type");
		return false;
	case MAP_Heightfield:
	case MAP_WaterMap:
		// OK
		break;
	}

	// get the options list
	ZLIST hOptions = theAPI.format_GetOptionList(hFormat);
	if(!hOptions) {
		theAPI.ReportError("CL3DTio_HTFApp::SaveMapFile error:\r\n - cannot retrieve options list");
		return false;
	}

	// defaults
	int TileSize = 64;
	bool Overlap = true;
	int PackMode = HTF_PACK_RAW;
	int InvertAxes = HTF_INVERT_NONE;
	int VertMode = HTF_SCALE_CLIP;

	theAPI.format_GetOptionValue(hFormat, "TileSize", VarID_int, &TileSize);
	theAPI.format_GetOptionValue(hFormat, "Overlap", VarID_bool, &Overlap);

	ZVAR hComboSel;
	
	/*if(hComboSel = theAPI.list_GetItemA(hOptions, "PackMode")) {
		CString SelStr;
		SelStr.SetString(theAPI.combosel_GetCurSel(hComboSel));
		if(SelStr.CompareNoCase("Raw")==0)	PackMode = HTF_PACK_RAW;
		else
		if(SelStr.CompareNoCase("RLE")==0)	PackMode = HTF_PACK_RLE;
		else
		if(SelStr.CompareNoCase("DIFF")==0)	PackMode = HTF_PACK_DIFF;
		else
		if(SelStr.CompareNoCase("Best")==0)	PackMode = HTF_PACK_BEST;
	}*/

	if(hComboSel = theAPI.list_GetItemA(hOptions, "FlipAxes")) {
		CString SelStr;
		SelStr.SetString(theAPI.combosel_GetCurSel(hComboSel));
		if(SelStr.CompareNoCase("None")==0)	
			PackMode = HTF_INVERT_NONE;
		else
		if(SelStr.CompareNoCase("X-axis")==0)	
			PackMode = HTF_INVERT_X;
		else
		if(SelStr.CompareNoCase("Y-axis")==0)	
			PackMode = HTF_INVERT_Y;
		else
		if(SelStr.CompareNoCase("Both")==0)	
			PackMode = HTF_INVERT_BOTH;
	}

	if(hComboSel = theAPI.list_GetItemA(hOptions, "VertMode")) {
		CString SelStr;
		SelStr.SetString(theAPI.combosel_GetCurSel(hComboSel));
		if(SelStr.CompareNoCase("Span 16-bit range")==0)	
			PackMode = HTF_SCALE_STRETCH;
		else
		if(SelStr.CompareNoCase("Clip to metres")==0)	
			PackMode = HTF_SCALE_CLIP;
	}

	// getting map size
	long nx = theAPI.map_GetWidth(hMap);
	long ny = theAPI.map_GetHeight(hMap);
	if(nx<=0||ny<=0) {
		theAPI.ReportError("CL3DTio_HTFApp::SaveMapFile error\r\n - invalid map size");
		return false;
	}

	if(TileSize<=1)
		TileSize = max(nx, ny);

	int TileSizeWithOverlap;
	if(Overlap) TileSizeWithOverlap = TileSize+1;
	else		TileSizeWithOverlap = TileSize;
	
	struct _iobuf *fh;
	USHORT TempUSHORT;
	float HFpxl;
	WaterMapPixel WMpxl;
	__int64 TempInt64;
	int TempInt;
	short int TempShort;

	float VertScale = 1;

	// getting scale
	float HFmin, HFmax;
	if(theAPI.map_GetMinMaxAlt(hMap, HFmin, HFmax)) {
		VertScale=32767.0f / max(fabs(HFmin), fabs(HFmax));
	}


	// getting scale
	switch(VertMode) {
	default:
	case HTF_SCALE_CLIP:
		VertScale = 1;
		break;
	case HTF_SCALE_STRETCH:		
		switch(MapType) {
		case MAP_Heightfield:
			// scale is OK
			break;
		case MAP_WaterMap:
			// retrieve the heightfield scale if possible
			if(theAPI.project_GetHeightfieldRange(HFmin, HFmax)) {
				VertScale=32767.0f / max(fabs(HFmin), fabs(HFmax));
			}
			break;
		}
		break;
	}

	// getting tile sizes, etc
	int nTilesX, nTilesY, nTiles;
	nTilesX = nx/TileSize;
	if(nx%TileSize)	nTilesX++;
	nTilesY = ny/TileSize;
	if(ny%TileSize)	nTilesY++;

	nTiles = nTilesX * nTilesY;


	// allocate array for height tile info structures
	HeightTileInfoStruct* pTileInfo = (HeightTileInfoStruct*)calloc(nTiles, sizeof(HeightTileInfoStruct));
	
	// opening file for writing
	fh=fopen(lpFileName, "wb"); 
	if(fh==NULL) {
		CString TempStr;
		TempStr.Format("CL3DTio_HTFApp::SaveMapFile error\r\n - cannot create file '%s'", lpFileName);
		theAPI.ReportError(TempStr);
		return false;
	}

	// preparing progress bar
	__int64 p, q, pmax, qstep;
	MSG TempMSG;
	if(hProgWnd) {
		theAPI.progbox_SetTitle(hProgWnd, "Saving HTF");
		theAPI.progbox_ShowWnd(hProgWnd);
		pmax = nTiles;
		qstep = (__int64)pmax/50; // HACK!
		if(qstep<1)	qstep=1;
		else 		pmax=50;
		q=0, p=0;
	}

	// writing file identifier (6 chars)
	char FileVersion[7] = "HTF100";
	fwrite(FileVersion, 6, 1, fh);

	// writing 'tile index offset' (int64) <- this is the start of the TileInfo array (at end of file, following data)
	TempInt64 = 28 + nTiles * ((TileSizeWithOverlap) * (TileSizeWithOverlap) * 2 + TileSizeWithOverlap);	// 28 is header length, rest is size of data block
	fwrite(&TempInt64, 8, 1, fh);

	// writing x & y (both ints)
	fwrite(&nx, 4, 1, fh);
	fwrite(&ny, 4, 1, fh);

	// writing tile size (int)
	TempInt = TileSizeWithOverlap;		
	fwrite(&TempInt, 4, 1, fh);

	// writing default z value (USHORT)
	TempUSHORT = 0;
	fwrite(&TempUSHORT, 2, 1, fh);

	int i, j;

	int bk;

	__int64 Offset = 28;	// as it is after end of header

	short int MaxAlt, MinAlt, AvgAlt;
	float sum;
	int counter = 0;

	bool MinMaxOK;
	bool PxlOK;

	BYTE TempByte;


	bool InvertY = false, InvertX = false;

	switch(InvertAxes) {
	default:
	case HTF_INVERT_NONE:
		break;
	case HTF_INVERT_X:
		InvertX = true;
		break;
	case HTF_INVERT_Y:
		InvertY = true;
		break;
	case HTF_INVERT_BOTH:
		InvertX = true;
		InvertY = true;
		break;
	}


	int idash, jdash;


	for(int bj=0; bj<nTilesY; bj++) {
	for(int bi=0; bi<nTilesX; bi++) {

		if(hProgWnd) {
			if(q==qstep)	{ p++; q=0; }
			if(q++==0) {
				PeekMessage(&TempMSG, NULL, 0, 0, PM_REMOVE);
				theAPI.progbox_SetProgress(hProgWnd, p, pmax);
			}
		}

		bk = bi + bj * nTilesX;

		MinAlt = 0;
		MaxAlt = 0;
		AvgAlt = 0;
		sum = 0;
		counter=0;

		MinMaxOK = false;

		// now write block data
		for(jdash = 0; jdash<TileSizeWithOverlap; jdash++) {

		// write byte at start of each line
		TempByte = 0;	// 0 specifies 'raw' data
		fwrite(&TempByte, 1, 1, fh);

		for(idash = 0; idash<TileSizeWithOverlap; idash++) {

			i = bi*TileSize + idash;
			j = bj*TileSize + jdash;
			
			// note that this method of inverting the maps does not translate well to
			// mosaics, as the i & j coordinates used do not correspond to the current block
			if(InvertX)	i = nx - i;
			if(InvertY)	j = ny - j;

			counter++;

			PxlOK = false;

			TempShort = -32768;
			switch(MapType) {
			case MAP_Heightfield:
				if(theAPI.map_GetPixel(hMap, i, j, &HFpxl)) {
					TempShort = (short int)(HFpxl * VertScale);
					PxlOK = true;
				}
				break;
			case MAP_WaterMap:
				if(theAPI.map_GetPixel(hMap, i, j, &WMpxl)) {
					if(WMpxl.Type!=0) {
						TempShort = (short int)(WMpxl.WaterLevel*VertScale);
						PxlOK = true;
					}
				}
				break;
			}

			fwrite(&TempShort, 2, 1, fh);

			if(PxlOK) {
				if(!MinMaxOK) {
					MinAlt = TempShort;
					MaxAlt = TempShort;
					MinMaxOK = true;
				} else {
					if(TempShort<MinAlt)	MinAlt = TempShort;
					if(TempShort>MaxAlt)	MaxAlt = TempShort;
				}
				sum+=(float)TempShort;	/// rounding errors ahoy!
			}
		}
		}

		pTileInfo[bk].x0 = bi*TileSize;
		pTileInfo[bk].y0 = bj*TileSize;

		pTileInfo[bk].nx = TileSizeWithOverlap;
		pTileInfo[bk].ny = TileSizeWithOverlap;
		pTileInfo[bk].MinAlt = MinAlt;
		pTileInfo[bk].MaxAlt = MaxAlt;
		pTileInfo[bk].AvgAlt = (short int) (sum / (float)counter);
		pTileInfo[bk].FileOffset = Offset;

		// increment offset for next block
		Offset+=counter*2+TileSizeWithOverlap;	// TileSize is for byte addition
	}
	}

	// write number of tiles
	fwrite(&nTiles, 4, 1, fh);

	// write tile info
	for(i=0; i<nTiles; i++) {
		fwrite(&pTileInfo[i].x0, 4, 1, fh);
		fwrite(&pTileInfo[i].y0, 4, 1, fh);
		fwrite(&pTileInfo[i].nx, 4, 1, fh);
		fwrite(&pTileInfo[i].ny, 4, 1, fh);
		fwrite(&pTileInfo[i].MinAlt, 2, 1, fh);
		fwrite(&pTileInfo[i].MaxAlt, 2, 1, fh);
		fwrite(&pTileInfo[i].AvgAlt, 2, 1, fh);
		fwrite(&pTileInfo[i].FileOffset, 8, 1, fh);
	}

	// done, so clean-up
	free(pTileInfo);

	fclose(fh);

	if(hProgWnd) {
		theAPI.progbox_HideWnd(hProgWnd);
	}

	return true;
}