// L3DTio_HTF.h : main header file for the L3DTio_HTF DLL
//

#pragma once

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols

#include "..\Plugin API\ExtAPI.h"


// HTF defines
#define HTF_PACK_RAW	0
#define HTF_PACK_DIFF	1
#define HTF_PACK_RLE	2
#define HTF_PACK_BEST	3
#define HTF_INVERT_NONE	0
#define HTF_INVERT_X	1
#define HTF_INVERT_Y	2
#define HTF_INVERT_BOTH	3
#define HTF_SCALE_CLIP	0
#define HTF_SCALE_STRETCH	1

typedef struct {
	short int MinAlt, MaxAlt, AvgAlt;
	int x0, y0, nx, ny;
    __int64 FileOffset;
} HeightTileInfoStruct;


// CL3DTio_HTFApp
// See L3DTio_HTF.cpp for the implementation of this class
//

class CL3DTio_HTFApp : public CWinApp
{
public:
	CL3DTio_HTFApp();

// Overrides
public:
	virtual BOOL InitInstance();


	bool InitPlugin(FARPROC pFunc, LPVOID hID);
	bool SaveMapFile(ZMAP hMap, LPCSTR lpFileName, ZFORMAT hFormat, ZVAR hProgWnd);


	DECLARE_MESSAGE_MAP()
};
