#pragma once
//#include "afx.h"
#include "extapi_defines.h"

// app function handle defs

typedef FARPROC (__stdcall* LPFNAPI_app_GetFuncHandle)(LPVOID hID, LPCSTR lpFuncHandle);
typedef void (__stdcall* LPFNAPI_app_ReportError)(LPVOID hID, LPCSTR lpErrorStr);

// var function handle defs

typedef ZVAR (__stdcall* LPFNAPI_var_Create)(LPVOID hID, long VarID, LPCSTR lpVarName);
typedef ZVAR (__stdcall* LPFNAPI_var_CreateTemp)(LPVOID hID, long VarID);
typedef bool (__stdcall* LPFNAPI_var_Delete)(LPVOID hID, ZVAR hVar);
typedef bool (__stdcall* LPFNAPI_var_Rename)(LPVOID hID, ZVAR hVar, LPCSTR lpNewName);
typedef ZVAR (__stdcall* LPFNAPI_var_GetVar)(LPVOID hID, LPCSTR lpVarName);
typedef LPCSTR (__stdcall* LPFNAPI_var_GetName)(LPVOID hID, ZVAR hVar);
typedef long (__stdcall* LPFNAPI_var_GetTypeID)(LPVOID hID, ZVAR hVar);
typedef bool (__stdcall* LPFNAPI_var_IsType)(LPVOID hID, ZVAR hVar, long VarID);
typedef bool (__stdcall* LPFNAPI_var_GetValue)(LPVOID hID, ZVAR hVar, void* pValue);
typedef bool (__stdcall* LPFNAPI_var_SetValue)(LPVOID hID, ZVAR hVar, void* pValue);
typedef bool (__stdcall* LPFNAPI_var_GetValueEx)(LPVOID hID, ZVAR hVar, long VarID, void* pValue);
typedef bool (__stdcall* LPFNAPI_var_SetValueEx)(LPVOID hID, ZVAR hVar, long VarID, void* pValue);
typedef bool (__stdcall* LPFNAPI_var_CopyValue)(LPVOID hID, ZVAR hVarDest, ZVAR hVarSrc);

// type function handle defs

typedef long (__stdcall* LPFNAPI_type_GetTypeID)(LPVOID hID, LPCSTR lpTypeName);
typedef bool (__stdcall* LPFNAPI_type_GetTypeName)(LPVOID hID, long VarID, ZVAR hStringVar);

// string function handle defs

typedef LPCSTR (__stdcall* LPFNAPI_str_GetText)(LPVOID hID, ZVAR hStr);
typedef bool (__stdcall* LPFNAPI_str_SetText)(LPVOID hID, ZVAR hStr, LPCSTR lpText);

// list function handle defs

typedef ZLIST (__stdcall* LPFNAPI_list_GetList)(LPVOID hID, LPCSTR lpListName);
typedef long (__stdcall* LPFNAPI_list_nItems)(LPVOID hID, ZLIST hList);
typedef ZLIST (__stdcall* LPFNAPI_list_CreateItem)(LPVOID hID, ZLIST hList, long VarID, LPCSTR lpVarName);
typedef ZLIST (__stdcall* LPFNAPI_list_GetItemI)(LPVOID hID, ZLIST hList, long index);
typedef ZLIST (__stdcall* LPFNAPI_list_GetItemA)(LPVOID hID, ZLIST hList, LPCSTR lpVarName);
typedef bool (__stdcall* LPFNAPI_list_DelItemI)(LPVOID hID, ZLIST hList, long index);
typedef bool (__stdcall* LPFNAPI_list_DelItemA)(LPVOID hID, ZLIST hList, LPCSTR lpVarName);
typedef bool (__stdcall* LPFNAPI_list_DelAll)(LPVOID hID, ZLIST hList);

// map function handle defs

typedef ZMAP (__stdcall* LPFNAPI_map_GetMap)(LPVOID hID, LPCSTR lpMapName);
typedef bool (__stdcall* LPFNAPI_map_Init)(LPVOID hID, ZMAP hMap, long nx, long ny, long MapTypeID, float HorizScale, bool WrapFlag);
typedef bool (__stdcall* LPFNAPI_map_Free)(LPVOID hID, ZMAP hMap);
typedef long (__stdcall* LPFNAPI_map_GetPixelSize)(LPVOID hID, ZMAP hMap);
typedef bool (__stdcall* LPFNAPI_map_GetWrapFlag)(LPVOID hID, ZMAP hMap);
typedef long (__stdcall* LPFNAPI_map_GetMapType)(LPVOID hID, ZMAP hMap);
typedef long (__stdcall* LPFNAPI_map_GetWidth)(LPVOID hID, ZMAP hMap);
typedef long (__stdcall* LPFNAPI_map_GetHeight)(LPVOID hID, ZMAP hMap);
typedef bool (__stdcall* LPFNAPI_map_GetPixel)(LPVOID hID, ZMAP hMap, long x, long y, void* pValue);
typedef bool (__stdcall* LPFNAPI_map_SetPixel)(LPVOID hID, ZMAP hMap, long x, long y, void* pValue);
typedef bool (__stdcall* LPFNAPI_map_GetMinMaxAlt)(LPVOID hID, ZMAP hMap, float& minval, float& maxval);
typedef float (__stdcall* LPFNAPI_map_GetHorizScale)(LPVOID hID, ZMAP hMap);
typedef bool (__stdcall* LPFNAPI_map_GetMosaicFlag)(LPVOID hID, ZMAP hMap);
typedef long (__stdcall* LPFNAPI_map_GetMosaicTileSize)(LPVOID hID, ZMAP hMap);
typedef long (__stdcall* LPFNAPI_map_GetMosaicTilesX)(LPVOID hID, ZMAP hMap);
typedef long (__stdcall* LPFNAPI_map_GetMosaicTilesY)(LPVOID hID, ZMAP hMap);

// mosaic tile function defs

typedef bool (__stdcall* LPFNAPI_tile_GetMinMaxAlt)(LPVOID hID, LPVOID hTile, float& minval, float& maxval);
typedef bool (__stdcall* LPFNAPI_tile_GetPixel)(LPVOID hID, LPVOID hTile, long x, long y, void* pValue);
typedef bool (__stdcall* LPFNAPI_tile_SetPixel)(LPVOID hID, LPVOID hTile, long x, long y, void* pValue);

// format function handle defs

typedef ZFORMAT (__stdcall* LPFNAPI_format_Create)(LPVOID hID, LPCSTR lpMapName, LPCSTR lpLongName, LPCSTR lpFileExt, LPCSTR lpNativeProgramName);
typedef ZFORMAT (__stdcall* LPFNAPI_format_CreateGeneric)(LPVOID hID, long MapTypeID, LPCSTR lpLongName, LPCSTR lpFileExt, LPCSTR lpNativeProgramName);
typedef bool (__stdcall* LPFNAPI_format_SetFlags)(LPVOID hID, ZFORMAT hFormat, bool Native, bool Mosaic);
typedef LPCSTR (__stdcall* LPFNAPI_format_GetExt)(LPVOID hID, ZFORMAT hFormat);
typedef ZLIST (__stdcall* LPFNAPI_format_GetOptionList)(LPVOID hID, ZFORMAT hFormat);
typedef bool (__stdcall* LPFNAPI_format_GetOptionValue)(LPVOID hID, ZFORMAT hFormat, LPCSTR lpOptionName, long VarID, void* pValue);
typedef bool (__stdcall* LPFNAPI_format_SetOptionValue)(LPVOID hID, ZFORMAT hFormat, LPCSTR lpOptionName, long VarID, void* pValue);

// prog box function handle defs

typedef bool (__stdcall* LPFNAPI_progbox_ShowWnd)(LPVOID hID, ZVAR hProgWnd);
typedef bool (__stdcall* LPFNAPI_progbox_HideWnd)(LPVOID hID, ZVAR hProgWnd);
typedef bool (__stdcall* LPFNAPI_progbox_SetTitle)(LPVOID hID, ZVAR hProgWnd, LPCSTR lpTitleText);
typedef bool (__stdcall* LPFNAPI_progbox_SetProgress)(LPVOID hID, ZVAR hProgWnd, __int64 p, __int64 pmax);

// combo box function handle defs

typedef bool (__stdcall* LPFNAPI_combosel_SetOptions)(LPVOID hID, ZVAR hComboSel, LPCSTR lpOptionsStr);
typedef LPCSTR (__stdcall* LPFNAPI_combosel_GetOptions)(LPVOID hID, ZVAR hComboSel);
typedef bool (__stdcall* LPFNAPI_combosel_SetCurSel)(LPVOID hID, ZVAR hComboSel, LPCSTR lpCurSelStr);
typedef LPCSTR (__stdcall* LPFNAPI_combosel_GetCurSel)(LPVOID hID, ZVAR hComboSel);

// buffer function handle defs

typedef bool (__stdcall* LPFNAPI_buffer_Init)(LPVOID hID, ZVAR hBuf, long nItems, long ItemSize);
typedef bool (__stdcall* LPFNAPI_buffer_Free)(LPVOID hID, ZVAR hBuf);
typedef long (__stdcall* LPFNAPI_buffer_nItems)(LPVOID hID, ZVAR hBuf);
typedef long (__stdcall* LPFNAPI_buffer_MemSize)(LPVOID hID, ZVAR hBuf);
typedef long (__stdcall* LPFNAPI_buffer_ItemSize)(LPVOID hID, ZVAR hBuf);
typedef LPVOID (__stdcall* LPFNAPI_buffer_GetPtr)(LPVOID hID, ZVAR hBuf);
typedef bool (__stdcall* LPFNAPI_buffer_GetValue)(LPVOID hID, ZVAR hBuf, long index, void* pValue);
typedef bool (__stdcall* LPFNAPI_buffer_SetValue)(LPVOID hID, ZVAR hBuf, long index, void* pValue);

// project function handle defs

typedef bool (__stdcall* LPFNAPI_project_GetHeightfieldRange)(LPVOID hID, float& minval, float& maxval);

// calculation functions

typedef COLORREF (__stdcall* LPFNAPI_calc_AM_GetPixelColour)(LPVOID hID, AttributesPixel AMpxl);
typedef AttributesPixel (__stdcall* LPFNAPI_calc_AM_GetIDfromColour)(LPVOID hID, COLORREF col);

// file/dir functions

typedef LPCSTR (__stdcall* LPFNAPI_file_GetExt)(LPVOID hID, LPCSTR lpFileName);
typedef bool (__stdcall* LPFNAPI_file_FileExists)(LPVOID hID, LPCSTR lpFileName);

// extension functions

typedef ZVAR (__stdcall* LPFNAPI_zeofunc_LoadFunc)(LPVOID hID, LPCSTR lpFnName, long rvalVarID, ZLIST hArgList);
typedef ZVAR (__stdcall* LPFNAPI_zeofunc_LoadFuncEx)(LPVOID hID, LPCSTR lpFnName, LPCSTR lpExportName, long rvalVarID, ZLIST hArgList);
typedef ZVAR (__stdcall* LPFNAPI_zeofunc_GetFunc)(LPVOID hID, LPCSTR lpFnName);
typedef long (__stdcall* LPFNAPI_zeofunc_GetReturnTypeID)(LPVOID hID, ZFUNC hFunc);
typedef bool (__stdcall* LPFNAPI_zeofunc_GetArgListPrototype)(LPVOID hID,  ZFUNC hFunc, ZLIST hArgList);
typedef ZVAR (__stdcall* LPFNAPI_zeofunc_Execute)(LPVOID hID, ZFUNC hFunc, ZLIST hArgList);


class CExtAPI :
	public CObject
{
public:
	CExtAPI(void);
	~CExtAPI(void);

	bool InitAPI(FARPROC pFunc, LPVOID hID);

	// app functions

	void	ReportError(LPCSTR lpErrorMessage);

	// var functions

	ZVAR	var_Create(long VarID, LPCSTR lpVarName);
	ZVAR	var_CreateTemp(long VarID);
	bool	var_Delete(ZVAR hVar);
	bool	var_Rename(ZVAR hVar, LPCSTR lpNewName);
	ZVAR	var_GetVar(LPCSTR lpVarName);
	LPCSTR	var_GetName(ZVAR hVar);
	long	var_GetTypeID(ZVAR hVar);
	bool	var_IsType(ZVAR hVar, long VarID);
	bool	var_GetValue(ZVAR hVar, void* pValue);
	bool	var_SetValue(ZVAR hVar, void* pValue);
	bool	var_GetValueEx(ZVAR hVar, long VarID, void* pValue);
	bool	var_SetValueEx(ZVAR hVar, long VarID, void* pValue);
	bool	var_CopyValue(ZVAR hVarDest, ZVAR hVarSrc);

	// type functions

	long	type_GetTypeID(LPCSTR lpTypeName);
	bool	type_GetTypeName(long VarID, ZVAR hStringVar);

	// string functions

	LPCSTR	str_GetText(ZVAR hStr);
	bool	str_SetText(ZVAR hStr, LPCSTR lpText);

	// list functions

	ZLIST	list_GetList(LPCSTR lpListName);
	long	list_nItems(ZLIST hList);
	ZLIST	list_CreateItem(ZLIST hList, long VarID, LPCSTR lpVarName);
	ZLIST	list_GetItemI(ZLIST hList, long index);
	ZLIST	list_GetItemA(ZLIST hList, LPCSTR lpVarName);
	bool	list_DelItemI(ZLIST hList, long index);
	bool	list_DelItemA(ZLIST hList, LPCSTR lpVarName);
	bool	list_DelAll(ZLIST hList);

	// map functions

	ZMAP	map_GetMap(LPCSTR lpMapName);
	bool	map_Init(ZMAP hMap, long nx, long ny, long MapTypeID, float HorizScale, bool WrapFlag);
	bool	map_Free(ZMAP hMap);
	long	map_GetMapType(ZMAP hMap);
	long	map_GetPixelSize(ZMAP hMap);
	bool	map_GetWrapFlag(ZMAP hMap);
	long	map_GetWidth(ZMAP hMap);
	long	map_GetHeight(ZMAP hMap);
	bool	map_GetPixel(ZMAP hMap, long x, long y, void* pValue);
	bool	map_SetPixel(ZMAP hMap, long x, long y, void* pValue);
	bool	map_GetMinMaxAlt(ZMAP hMap, float& minval, float& maxval);
	float	map_GetHorizScale(ZMAP hMap);
	bool	map_GetMosaicFlag(ZMAP hMap);
	long	map_GetMosaicTileSize(ZMAP hMap);
	long	map_GetMosaicTilesX(ZMAP hMap);
	long	map_GetMosaicTilesY(ZMAP hMap);

	// mosaic tile functions

	bool	tile_GetMinMaxAlt(LPVOID hTile, float& minval, float& maxval);
	bool	tile_GetPixel(LPVOID hTile, long x, long y, void* pValue);
	bool	tile_SetPixel(LPVOID hTile, long x, long y, void* pValue);

	//format functions

	ZFORMAT format_Create(LPCSTR lpMapName, LPCSTR lpLongName, LPCSTR lpFileExt, LPCSTR lpNativeProgramName);
	ZFORMAT format_CreateGeneric(long MapTypeID, LPCSTR lpLongName, LPCSTR lpFileExt, LPCSTR lpNativeProgramName);
	bool	format_SetFlags(ZFORMAT hFormat, bool Native, bool Mosaic);
	LPCSTR	format_GetExt(ZFORMAT hFormat);
	ZLIST	format_GetOptionList(ZFORMAT hFormat);
	bool	format_GetOptionValue(ZFORMAT hFormat, LPCSTR lpOptionName, long VarID, void* pValue);
	bool	format_SetOptionValue(ZFORMAT hFormat, LPCSTR lpOptionName, long VarID, void* pValue);

	// prog box functions

	bool progbox_ShowWnd(ZVAR hProgWnd);
	bool progbox_HideWnd(ZVAR hProgWnd);
	bool progbox_SetTitle(ZVAR hProgWnd, LPCSTR lpTitleText);
	bool progbox_SetProgress(ZVAR hProgWnd, __int64 p, __int64 pmax);

	// combo box functions

	bool	combosel_SetOptions(ZVAR hComboSel, LPCSTR lpOptionsStr);
	LPCSTR	combosel_GetOptions(ZVAR hComboSel);
	bool	combosel_SetCurSel(ZVAR hComboSel, LPCSTR lpCurSelStr);
	LPCSTR	combosel_GetCurSel(ZVAR hComboSel);

	// project functions

	bool	project_GetHeightfieldRange(float& minval, float& maxval);

	// calculation functions

	COLORREF		calc_AM_GetPixelColour(AttributesPixel AMpxl);
	AttributesPixel calc_AM_GetIDfromColour(COLORREF col);

	// file/dir functions

	LPCSTR	file_GetExt(LPCSTR lpFileName);
	bool	file_FileExists(LPCSTR lpFileName);

	// buffer function handle defs

	bool	buffer_Init(ZVAR hBuf, long nItems, long ItemSize);
	bool	buffer_Free(ZVAR hBuf);
	long	buffer_nItems(ZVAR hBuf);
	long	buffer_MemSize(ZVAR hBuf);
	long	buffer_ItemSize(ZVAR hBuf);
	LPVOID	buffer_GetPtr(ZVAR hBuf);
	bool	buffer_GetValue(ZVAR hBuf, long index, void* pValue);
	bool	buffer_SetValue(ZVAR hBuf, long index, void* pValue);

	// extension functions

	ZVAR	zeofunc_LoadFunc(LPCSTR lpFnName, long rvalVarID, ZLIST hArgList);
	ZVAR	zeofunc_LoadFuncEx(LPCSTR lpFnName, LPCSTR lpExportName, long rvalVarID, ZLIST hArgList);
	ZVAR	zeofunc_GetFunc(LPCSTR lpFnName);
	long	zeofunc_GetReturnTypeID(ZFUNC hFunc);
	bool	zeofunc_GetArgListPrototype(ZFUNC hFunc, ZLIST hArgList);
	ZVAR	zeofunc_Execute(ZFUNC hFunc, ZLIST hArgList);

protected:

	// bootstrapping function

	FARPROC GetFuncHandle(LPCSTR lpFuncName);

	// session ID's

	LPVOID m_hID;

	// app function handles

	LPFNAPI_app_GetFuncHandle	m_lpfnGetFuncHandle;
	LPFNAPI_app_ReportError		m_lpfnReportError;

	// var function handles

	LPFNAPI_var_Create			m_lpfn_var_Create;
	LPFNAPI_var_CreateTemp		m_lpfn_var_CreateTemp;
	LPFNAPI_var_Delete			m_lpfn_var_Delete;
	LPFNAPI_var_Rename			m_lpfn_var_Rename;
	LPFNAPI_var_GetVar			m_lpfn_var_GetVar;
	LPFNAPI_var_GetName			m_lpfn_var_GetName;
	LPFNAPI_var_GetTypeID		m_lpfn_var_GetTypeID;
	LPFNAPI_var_IsType			m_lpfn_var_IsType;
	LPFNAPI_var_GetValue		m_lpfn_var_GetValue;
	LPFNAPI_var_SetValue		m_lpfn_var_SetValue;
	LPFNAPI_var_GetValueEx		m_lpfn_var_GetValueEx;
	LPFNAPI_var_SetValueEx		m_lpfn_var_SetValueEx;
	LPFNAPI_var_CopyValue		m_lpfn_var_CopyValue;

	// type function handles

	LPFNAPI_type_GetTypeID		m_lpfn_type_GetTypeID;
	LPFNAPI_type_GetTypeName	m_lpfn_type_GetTypeName;

	// string function handles

	LPFNAPI_str_GetText			m_lpfn_str_GetText;
	LPFNAPI_str_SetText			m_lpfn_str_SetText;

	// list function handles

	LPFNAPI_list_GetList		m_lpfn_list_GetList;
	LPFNAPI_list_nItems			m_lpfn_list_nItems;
	LPFNAPI_list_CreateItem		m_lpfn_list_CreateItem;
	LPFNAPI_list_GetItemI		m_lpfn_list_GetItemI;
	LPFNAPI_list_GetItemA		m_lpfn_list_GetItemA;
	LPFNAPI_list_DelItemI		m_lpfn_list_DelItemI;
	LPFNAPI_list_DelItemA		m_lpfn_list_DelItemA;
	LPFNAPI_list_DelAll			m_lpfn_list_DelAll;

	// map function handles

	LPFNAPI_map_GetMap			m_lpfn_map_GetMap;
	LPFNAPI_map_Init			m_lpfn_map_Init;
	LPFNAPI_map_Free			m_lpfn_map_Free;
	LPFNAPI_map_GetMapType		m_lpfn_map_GetMapType;
	LPFNAPI_map_GetPixelSize	m_lpfn_map_GetPixelSize;
	LPFNAPI_map_GetWrapFlag		m_lpfn_map_GetWrapFlag;
	LPFNAPI_map_GetWidth		m_lpfn_map_GetWidth;
	LPFNAPI_map_GetHeight		m_lpfn_map_GetHeight;
	LPFNAPI_map_GetPixel		m_lpfn_map_GetPixel;
	LPFNAPI_map_SetPixel		m_lpfn_map_SetPixel;
	LPFNAPI_map_GetMinMaxAlt	m_lpfn_map_GetMinMaxAlt;
	LPFNAPI_map_GetHorizScale	m_lpfn_map_GetHorizScale;
	LPFNAPI_map_GetMosaicFlag		m_lpfn_map_GetMosaicFlag;
	LPFNAPI_map_GetMosaicTileSize	m_lpfn_map_GetMosaicTileSize;
	LPFNAPI_map_GetMosaicTilesX		m_lpfn_map_GetMosaicTilesX;
	LPFNAPI_map_GetMosaicTilesY		m_lpfn_map_GetMosaicTilesY;

	// mosaic tile function handles

	LPFNAPI_tile_GetMinMaxAlt	m_lpfn_tile_GetMinMaxAlt;
	LPFNAPI_tile_GetPixel		m_lpfn_tile_GetPixel;
	LPFNAPI_tile_SetPixel		m_lpfn_tile_SetPixel;

	// format function handles

	LPFNAPI_format_Create			m_lpfn_format_Create;
	LPFNAPI_format_CreateGeneric	m_lpfn_format_CreateGeneric;
	LPFNAPI_format_SetFlags			m_lpfn_format_SetFlags;
	LPFNAPI_format_GetExt			m_lpfn_format_GetExt;
	LPFNAPI_format_GetOptionList	m_lpfn_format_GetOptionList;
	LPFNAPI_format_GetOptionValue	m_lpfn_format_GetOptionValue;
	LPFNAPI_format_SetOptionValue	m_lpfn_format_SetOptionValue;

	// prog box function handles

	LPFNAPI_progbox_ShowWnd			m_lpfn_progbox_ShowWnd;
	LPFNAPI_progbox_HideWnd			m_lpfn_progbox_HideWnd;
	LPFNAPI_progbox_SetTitle		m_lpfn_progbox_SetTitle;
	LPFNAPI_progbox_SetProgress		m_lpfn_progbox_SetProgress;

	// combo box function handles

	LPFNAPI_combosel_SetOptions		m_lpfn_combosel_SetOptions;
	LPFNAPI_combosel_GetOptions		m_lpfn_combosel_GetOptions;
	LPFNAPI_combosel_SetCurSel		m_lpfn_combosel_SetCurSel;
	LPFNAPI_combosel_GetCurSel		m_lpfn_combosel_GetCurSel;

	// buffer function handles

	LPFNAPI_buffer_Init			m_lpfn_buffer_Init;
	LPFNAPI_buffer_Free			m_lpfn_buffer_Free;
	LPFNAPI_buffer_nItems		m_lpfn_buffer_nItems;
	LPFNAPI_buffer_MemSize		m_lpfn_buffer_MemSize;
	LPFNAPI_buffer_ItemSize		m_lpfn_buffer_ItemSize;
	LPFNAPI_buffer_GetPtr		m_lpfn_buffer_GetPtr;
	LPFNAPI_buffer_GetValue		m_lpfn_buffer_GetValue;
	LPFNAPI_buffer_SetValue		m_lpfn_buffer_SetValue;

	// project function handles

	LPFNAPI_project_GetHeightfieldRange		m_lpfn_project_GetHeightfieldRange;

	// calculation function handles

	LPFNAPI_calc_AM_GetPixelColour			m_lpfn_calc_AM_GetPixelColour;
	LPFNAPI_calc_AM_GetIDfromColour			m_lpfn_calc_AM_GetIDfromColour;

	// file/dir function handles

	LPFNAPI_file_GetExt						m_lpfn_file_GetExt;
	LPFNAPI_file_FileExists					m_lpfn_file_FileExists;

	// extension function handles

	LPFNAPI_zeofunc_LoadFunc				m_lpfn_zeofunc_LoadFunc;
	LPFNAPI_zeofunc_LoadFuncEx				m_lpfn_zeofunc_LoadFuncEx;
	LPFNAPI_zeofunc_GetFunc					m_lpfn_zeofunc_GetFunc;
	LPFNAPI_zeofunc_GetReturnTypeID			m_lpfn_zeofunc_GetReturnTypeID;
	LPFNAPI_zeofunc_GetArgListPrototype		m_lpfn_zeofunc_GetArgListPrototype;
	LPFNAPI_zeofunc_Execute					m_lpfn_zeofunc_Execute;
};
